#!/usr/bin/perl
#!c:\Perl\bin\perl.exe

# PL0008.pm	
# Formular-Handling
# FORM_DECODE - Variablen von GET oder POST Requests, Request String


package EIGEN::Form::PL0008;

use strict;
use vars qw($VERSION @ISA @EXPORT @EXPORT_OK);

require Exporter;

@ISA       = qw(Exporter AuoLoader);
@EXPORT    = qw();
@EXPORT_OK = qw(FORM_DECODE);
$VERSION   = '1.0.0';

use CGI qw(:standard :OS);

##################################################################
# Voreinstellungen:
##################################################################


##################################################################
# Subroutinen:
##################################################################

##################################################################
# FORM_DECODE
# Variablen von GET oder POST Requests
#
# input: 
#
# output:\%Felder - alle bermittelten Felnamen u.Feldinhalte incl.
#                   submitButtonName=Name
#        $RequestUrl
#        z.B. http://www.abc.de/cgi-bin/mp.cgi?Feld1=Inhalt&absenden=Los!
#
#        In speziallen Fllen wird keine URL-Decodierung gewnscht,
#        dafr Routine mit FORM_DECODE(1) aufrufen.
##################################################################
sub FORM_DECODE
{
 my ($RequestUrl,@pairs,$temp,$item,$key,$content,%Felder,@sortlist,@mandatory,$i);
 
 $RequestUrl = 'http://'.$ENV{'SERVER_NAME'}.$ENV{'SCRIPT_NAME'}.'?'; # http://www.baurat.de/cgi-bin/boerse/MaterialPool/mp.cgi
 
 if ($ENV{'REQUEST_METHOD'} eq 'GET')
 {
# Namen-/Daten-Paare aufteilen
  @pairs = split(/&/, $ENV{'QUERY_STRING'});
 }
 elsif ($ENV{'REQUEST_METHOD'} eq 'POST')
 {
  read(STDIN,$temp,$ENV{'CONTENT_LENGTH'});
  @pairs=split(/&/,$temp);
 }
 $i = 0; 
 foreach $item(@pairs)
 {
  ($key,$content)=split(/=/,$item,2);
  $content=~tr/+/ /;
  unless ($_[0])
  {
   $content=~s/%(..)/pack("c",hex($1))/ge;
  }
  $content=~s/\t/ /g;
  $Felder{$key}=$content;
  if ($i==0) {$RequestUrl = $RequestUrl.$key.'='.$Felder{$key};}      # setzt Request als String zusammen
  else       {$RequestUrl = $RequestUrl.'&'.$key.'='.$Felder{$key};}  # incl. (leider) &submitButtonName=Name
  $i++;
 }
 
 return(\%Felder,$RequestUrl);
}
 
1;
__END__

=head1 NAME

=head1 SYNOPSIS

=head1 DESCRIPTION

=head1 AUTHOR

=head1SEE ALSO

=cut